class Queue {
    private int [] que;
    private int nextIn,nextOut,filled,queSize;
    
    public Queue(int size){
	que = new int[size];
	filled = 0;
	nextIn = 1;
	nextOut = 1;
	queSize = size;
    }

    public synchronized void deposit(int item)
    {
	while (filled == queSize){
	    try {
		wait();
	    } 
	    catch (InterruptedException e){};
	}
	que[nextIn] = item;
	nextIn = (nextIn + 1) % queSize;
	filled++;
	notify();
    }

    public synchronized int fetch()
    {
	int item;
	while (queSize==0){
	    try {
		wait();
	    } 
	    catch (InterruptedException e){};
	}
	item = que[nextOut];
	nextOut = (nextOut+1) % queSize;
	filled--;
	notify();
	return item;
    }
}
